/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	ir.c
//	Version		1.00
//	MCU		R8C/2A_2B
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2008/05/30	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	ԊOł̑MsAMf[^LCDɕ\܂B
//	DIP_SW̏ԂɂđMf[^ς܂B
//-------------------------------------------------------------------------------------------------
///////////////////////////////////////////////////////////////////////////////////////////////////
/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2008

*/
///////////////////////////////////////////////////////////////////////////////////////////////////
/* CN[ht@C錾 */

#include "R8C_2A_2B.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ^錾 */

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ϐ錾 */

unsigned int x, y;

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ֐̃vg^Cv錾 */

void init_IO ( void );
void set_CLK ( void );
void wait ( unsigned long msec );
void init_timer ( void );
void set_si ( void );
void si_write_long ( unsigned char *str );
void si_write ( unsigned char str );
void main ( void );
unsigned char irsi_chek ( void );
unsigned int dip_select (void);

void Init_LCD ( void );
void Write_LCD (const unsigned char RS_Mode ,const unsigned char Data);
void Write_LCD (const unsigned char RS_Mode ,const unsigned char Data);
void Clear_LCD ( void );
void Wait_LCD ( const unsigned long Interval );
void Print_LCD ( const char *String );
void IR_Print_LCD ( unsigned char String );

///////////////////////////////////////////////////////////////////////////////////////////////////
/* I/OCvbg */

void init_IO ( void )
{
	PRCR = 0x0f;		// veNgWX^
	PD0 = 0x00;		// P0_3~7dip_sw
	PD5 = 0xff;		// LCD_04~07
	PD6 = 0x03;		// LCD_E,LCD_RS
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* NbNZbg */

void set_CLK ( void )
{
/* ONbN20MHz */
	CM1 = 0x08;
	CM0 = 0x14; 
	OCD = 0x00; 
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD */

void Init_LCD ( void )
{
	P5 = 0x00;
	P6 = 0x00;

	Wait_LCD ( 20 );

	P6 = P6 & ~0x02;		// RS Low Set

	/* LCD1 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM1
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
	Wait_LCD ( 5 );

	/* LCD2 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM2
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* LCD3 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x03;	// MM3
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* LCD4 */
	P6 = P6 | 0x01;			// E High Set
	P5 = ( P5 & 0xf0 ) | 0x02;	// MM4
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* t@NVZbgF4rbgoXA2sA5~7hbg */
	Write_LCD ( 0 , 0x28 );

	/* Gg[[hFJ[\CNgAJ[\ړ */
	Write_LCD ( 0 , 0x06 );

	/* J[\/\VtgFJ[\EVtg */
	Write_LCD ( 0 , 0x10 );

	/* \ON/OFFRg[FfBXvC\AJ[\\AuN\ */
	Write_LCD ( 0 , 0x0d );

	/* \NA */
	Clear_LCD ();

	Wait_LCD ( 5 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Write_LCD (
	const unsigned char RS_Mode ,
	const unsigned char Data
)
{
	/* 4rbg̏ꍇ */
	/* RS Setting */
	if ( RS_Mode == 0 )
	{
		P6 = P6 & ~0x02;	// RS Low Set
	}
	else if ( RS_Mode == 1 )
	{
		P6 = P6 | 0x02;		// RS High Set
	}

	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set

	P5 = ( P5 & 0xf0 ) | (( Data >> 4 ) & 0x0f );	// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );

	/* 4rbg */
	P6 = P6 | 0x01;			// E High Set

	P5 = ( P5 & 0xf0 ) | (  Data & 0x0f );		// 4rbg
	Wait_LCD ( 1 );
	P6 = P6 & ~0x01;		// E Low Set
	Wait_LCD ( 1 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD J[\ړ */
	
void Locate_LCD ( const unsigned char X, const unsigned char Y )
{
	unsigned char i;
	i = Y * 0x40 + X;
	i = i | 0x80;
	
	Write_LCD ( 0 , i );
	Wait_LCD ( 1 );
	
	/* J[\ۑ */
	x = X;
	y = Y;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD NA\ */

void Clear_LCD ( void )
{
	P6 = P6 & ~0x02;	// RS Low Set
	Write_LCD ( 0 , 0x01 );
	Wait_LCD ( 2 );
	Locate_LCD ( 0 , 0 );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCgLCD */

void Wait_LCD ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* EFCg */

void wait ( unsigned long msec )
{
	volatile unsigned long i;
	for ( i = 0; i < msec * 1000; ++i );
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* LCD\ */

void Print_LCD ( const char *String )
{
	unsigned char i, j;
	
	/* \[v */
	for ( i = 0; String[ i ] != '\0'; ++i )
	{
		/* ` */
		if (
			( String[ i ] >= 0x20 && String[ i ] <= 0x7f ) ||
			( String[ i ] >= 0xa1 && String[ i ] <= 0xfd )
		)
		{/* kbcR[h͈͓̔̏ꍇ */
			/* ` */
			Write_LCD ( 1, String[ i ] );
			Wait_LCD ( 1 );
			
		/* J[\ړ */
			if ( x ==  16 - 1 )
			{/* 16sI[o[ꍇ */
				x = 0;
				y = ( y == 0 ? 1 : 0 );
				Locate_LCD ( x, y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++x;
				Locate_LCD ( x, y );
			}
		}
		else if ( String[ i ] == '\n' )
		{/* sR[h̏ꍇ */
			x = 0;
			y = ( y == 0 ? 1 : 0 );
			Locate_LCD ( x, y );
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* ^C}[(PWMo) */

void init_timer ( void )
{
	MSTCR = 0x10;		// ^C}RDgp\
	TRDPMR = 0x10;		// TRDIOB1 PWM[h
	TRDFCR = 0x80;		// ^C}RD@\
	TRDOER1 = 0xdf;		// TRDIOB1̂ݏo͋
	
	TRDCR1 = 0x23;		// JEg\[Xf8 GRAƂ̃RyA}b`TRDWX^NA
	TRDGRA1 = 65;		// PWMg20MHz/65 =38kHz  65
	TRDGRB1 = 33;		// PWMo f[eB50% 33
	
	asm(" MOV.B #0AH,0137H ");	//TRDSTRWX^ ^C}JEgX^[g
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* VAC^tF[XZbg */

void set_si ( void )
{
	/* 4800bpsŒʐM */
	PMR = 0x10;	// UART1
	U0MR = 0x05; 	// UART[h]f[^8rbg
	U0C0 = 0x01;	// BRGJEg\[X f8I
	U0C1 = 0x05;	// MAM
	asm(" MOV.B #26H,00A1H "); // U0BRG = 0x26; ƓӖ
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* o */
void si_write_long ( unsigned char *str )
{
	while( *str != '\0' )
	{					// I[o
		if( *str == '\n' )
		{				// so
			si_write (0x0a);
			si_write (0x0d);
		}
		else
		{				// o
			si_write ( *str );
		}
		str++;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* M */
void si_write ( unsigned char str )
{
	asm(" MOV.B $$[FB],00A2H ",str); // U0TB = str; ƓӖ
	while( !( U0C1 & 0x02 ) ){
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* IR_LCD\ */

void IR_Print_LCD ( unsigned char String )
{
		if (( String >= 0x20 && String <= 0x7f ) || ( String >= 0xa1 && String <= 0xfd )){
			Write_LCD ( 1, String );
			Wait_LCD ( 1 );
		}
			if ( x ==  16 - 1 )	/* J[\ړ */
			{/* 16sI[o[ꍇ */
				x = 0;
				y = ( y == 0 ? 1 : 0 );
				Locate_LCD ( x, y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++x;
				Locate_LCD ( x, y );
			}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* M */

unsigned char irsi_chek ( void )
{
	unsigned short code;
	
	if(( U0C1 & 0x08 ) == 0x08)		//Mf[^L
	{
		while( !( U0C1 & 0x08 ) ){
		}
			code = (unsigned short)U0RB;	
			IR_Print_LCD ( code );
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* dip_SW */

unsigned int dip_select (void)
{	
	unsigned int dip;
	unsigned int cun;
	
	dip = 0xff & P0;
	dip = dip >> 4;
	cun = 0;
	
	if((0x01 == (dip & 0x01))){
		cun = cun + 1;
	}
	if((0x02 == (dip & 0x02))){
		cun = cun + 1;
	}
	if((0x04 == (dip & 0x04))){
		cun = cun + 1;	
	}
	if((0x08 == (dip & 0x08))){
		cun = cun + 1;
	}
	return cun;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
/* C֐ */

void main ()
{	
	unsigned int dis;
	unsigned char Title[] = "IR              Sample program";
	unsigned char m_Str00[] = "+";
	unsigned char m_Str01[] = "-";
	unsigned char m_Str02[] = "*";
	unsigned char m_Str03[] = "/";
	unsigned char m_Str04[] = "!";
	
	init_IO ();	// I/OCvbg
	set_CLK ();	// NbNZbg
	Init_LCD ();	// LCD
	init_timer ();	// PWMݒ
	set_si ();	// VAC^[tF[X̏ݒ
	
	Print_LCD ( Title );
	wait (500);
	Clear_LCD ();	// LCDNA\
	
	while(1)
	{
		dis = dip_select ();//DIP_SW̒l
		
		if(dis == 0)
		{
			si_write_long ( m_Str00 );
		}
		else if(dis == 1)
		{
			si_write_long ( m_Str01 );
		}
		else if(dis == 2)
		{
			si_write_long ( m_Str02 );
		}
		else if(dis == 3)
		{
			si_write_long ( m_Str03 );
		}
		else if(dis == 4)
		{
			si_write_long ( m_Str04 );
		}
		irsi_chek ();
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
